#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include "check.h"

/* ************************************************************ */
/*    */
static void t_complex_add( t_complex_p this, t_complex_p c);
static void t_complex_sub( t_complex_p this, t_complex_p c);
static char t_complex_compare(t_complex_p this, t_complex_p c);

/* ************************************************************ */
void	check()
{
t_complex complex[2];

	t_complex_constructor(&complex[0]);
	t_complex_constructor(&complex[1]);

	complex[0].re=3;
	complex[1].im=4;
	/*    ,  */
	if(! (*(complex[0].compare))( &complex[0], &complex[1]) )
	 (*(complex[0].add))( &complex[0], &complex[1]);

	(*(complex[0].compare))( &complex[0], &complex[1]);
}

// *****************************************************************
/*  */
// *****************************************************************
void	t_complex_constructor(t_complex_p c)
{
	printf("In t_complex_constructor for [%p]\n",c);
	assert(c);
	c->add=t_complex_add;
	c->sub=t_complex_sub;
	c->compare=t_complex_compare;
	c->im=c->re=.0;
}

/* ************************************************************ */
void	t_complex_add(t_complex_p this, t_complex_p c)
{
	assert(this);
	assert(c);
	printf("[%p](%u,%u)+=[%p](%u,%u)\n",this,this->re,this->im,c,c->re,c->im);

	this->re+=c->re;
	this->im+=c->im;
}

/* ************************************************************ */
void	t_complex_sub(t_complex_p this, t_complex_p c)
{
	assert(this);
	assert(c);
	printf("[%p](%u,%u)-=[%p](%u,%u)\n",this,this->re,this->im,c,c->re,c->im);

	this->re-=c->re;
	this->im-=c->im;
}

/* ************************************************************ */
char	t_complex_compare(t_complex_p this, t_complex_p c)
{
char		res;

	assert(this);
	assert(c);

	if(
	   (this->re==c->re)
	   &&(this->im==c->im)
	  )res=1;
	else res=0;

	printf("[%p](%u,%u)%c=[%p](%u,%u)\n",this,this->re,this->im,res?'=':'!',c,c->re,c->im);
	//return res;
        return (char)( (this->re==c->re)&&(this->im==c->im) );
}

/* ************************************************************ */
