#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include "check.h"

/* ************************************************************ */
/*(2)*/
#define clear(v,n) switch((v)->type){\
  case 0: T1_clear( (T1*)((void*)(v)), (n) ); break;\
  case 1: T2_clear( (T2*)((void*)(v)), (n) ); break;\
  default: assert(0); }

T1 	var_1[50];
T2 	var_2[50];

void	T1_clear(T1*,int);
void	T2_clear(T2*,int);

/* ************************************************************ */
void	check()
{
int		i;

	/*(1)*/
	for(i=0; i<5; i++)
	 {
	  var_1[i].type=0;
	  var_2[i].type=1;
	  if(i&1)clear(&var_1[i], i)
	  else clear(&var_2[i], i)
	 }

	printf("\n");
	for(i=0; i<5; i++)
	 {
	  var_1[i].type=0;
	  var_2[i].type=1;
	  //,      type
	  //   
	  clear( (T1*)((i&1)? (void*)&var_1[i]:(void*)&var_2[i]),i);
	 }

}

// *****************************************************************
void	T1_clear(T1* v, int n)
{
	printf("T1:%u:[%p]\n",n,v);
}

void	T2_clear(T2* v, int n)
{
	printf("T2:%u:[%p]\n",n,v);
}

/* ************************************************************ */
